#pragma once

#include <sql.h>
#include <Text.h>
#include <InitDatei.h>

using namespace Framework;
using namespace sql;

namespace Admin_Recht
{
    const int LSStarten = 12;
    const int LSBeenden = 13;
    const int LSPausieren = 14;
    const int LSMCChange = 15;
}

class LSDatenbank : public virtual Framework::ReferenceCounter
{
private:
    Datenbank *datenbank;
    CRITICAL_SECTION cs;

public:
    // Konstruktor
    LSDatenbank( InitDatei *zIni );
    // Destruktor
    ~LSDatenbank();
    // nicht constant
    void lock();
    void unlock();
    int istAdministrator( const char *name, const char *passwort );
    bool adminHatRecht( int id, int recht );
    bool proveKlient( int num, int sNum );
    Text *getKlientKey( int cId );
    void unregisterKlient( int num, int sNum );
    bool setServerStatus( int id, int status );
    bool setMaxClients( int id, int maxC );
    bool serverIstNichtPausiert( int id );
    // constant
    Text *getLetzterFehler() const;
};