#pragma once

#include <Text.h>
#include <Punkt.h>
#include <Thread.h>

#include "Dimension.h"
#include "Player.h"
#include "WorldGenerator.h"
#include "Constants.h"
#include "WorldUpdate.h"
#include "WorldLoader.h"

class Game : public virtual Framework::Thread
{
private:
    Framework::Text name;
    Framework::RCArray<Dimension> *dimension;
    Framework::RCArray<Entity> *entities;
    Framework::RCArray<WorldUpdate> *updates;
    WorldGenerator *generator;
    WorldLoader *loader;
    __int64 tickId;

    void thread() override;
public:
    Game();
    ~Game();
    void requestWorldUpdate( WorldUpdate *update );
    bool doesChunkExist( int x, int y, int dimension ) const;
    Block *zBlockAt( Framework::Vec3<int> location, int dimension ) const;
    Framework::Punkt getChunkCenter( int x, int y ) const;
    Text getWorldDirectory() const;
    void requestArea( Area area );
    void save();
};