#pragma once

#include "Noise.h"
#include <vector>

class PerlinNoise : public Noise
{
private:
    std::vector<int> p;
    int seed;

public:
    PerlinNoise( int seed );

    int getSeed() const override;
    double getNoise( double x, double y, double z ) const override;

private:
    inline double fade( double t ) const;
    inline double lerp( double t, double a, double b ) const;
    inline double grad( int hash, double x, double y, double z ) const;
};