#pragma once

#include <ReferenceCounter.h>
#include <Vec3.h>
#include <Writer.h>

class Dimension;

class WorldUpdate : public Framework::ReferenceCounter
{
private:
    int affectedDimensionId;
    Framework::Vec3<int> minAffected;
    Framework::Vec3<int> maxAffected;

public:
    WorldUpdate( int dimensionId, Framework::Vec3<int> minAffected, Framework::Vec3<int> maxAffected );

    virtual void onUpdate( Dimension *zDimension ) = 0;
    virtual void write( Framework::Writer *zWriter ) = 0;

    int getAffectedDimension() const;
    const Framework::Vec3<int> &getMinAffectedPoint() const;
    const Framework::Vec3<int> &getMaxAffectedPoint() const;
};

